C 1997/9
C          INPUT DATA SYNTHESIZING PROGRAM
C     FOR BOUNDARY ELEMENT METHOD I2S CALCULATION
C          ------ I2VDSY FOR WINDOW95 ------
C                  BY TAKAYUKI HIRAI 
C
      COMMON JAA(50,50),JBB(50,50),DP(8000,2),P(8000,2,2),
     1   MD(8000),NSP(50),IP(50),SP(400,2),JA(50),JB(50),
     2   MM(8000),PRR(50),ENN(50),THH(50),M(8000),NEG(50),
     3   SSG(50)
      CHARACTER TITLE*5,TITLEB*5
C
C  ------------------- INPUT DATA -----------------
      OPEN(15,FILE='DA')
      NCR=0
      READ(15,1001) TITLE,NEA,NDA,NSA,XS,YS,XYS,
     1    (NSP(J),J=1,10)
      WRITE (*,2101) TITLE
      DO 12 I=1,NEA
   12 READ(15,1005) NEG(I),PRR(I),ENN(I),THH(I),
     1    IP(I),SSG(I),(JBB(I,J),J=1,10)
      DO 10 I=1,NDA
   10 READ(15,1002) N,MM(I),MD(I),(DP(I,J),J=
     1    1,2),((P(I,J,L),L=1,2),J=1,2)
      DO 11 I=1,NSA
   11 READ(15,1004) N,SP(I,1),SP(I,2)
      CLOSE(15)
      OPEN(15,FILE='DB')
      NCR=0
      READ(15,1001) TITLEB,NEB,NDB,NSB,XSB,YSB,XYSB,
     1    (NSP(J+NEA),J=1,10)
      NE=NEA+NEB
      ND=NDA+NDB
      NS=NSA+NSB
      DO 24 J=1,NEB
   24 NSP(J+NEA)=NSP(J+NEA)+NSP(NEA)
      WRITE (*,2101) TITLEB
      DO 22 I=1,NEB
      READ(15,1005) NEG(I+NEA),PRR(I+NEA),ENN(I+NEA),
     1    THH(I+NEA),IP(I+NEA),SSG(I+NEA),
     2    (JBB(I+NEA,J),J=1,10)
      JJ=NEG(I+NEA)
      DO 22 J=1,JJ
   22 JBB(I+NEA,J)=JBB(I+NEA,J)+JBB(NEA,NEG(NEA))
      DO 20 I=1,NDB
   20 READ(15,1002) N,MM(I+NDA),MD(I+NDA),
     1    (DP(I+NDA,J),J=1,2),
     2    ((P(I+NDA,J,L),L=1,2),J=1,2)
      DO 21 I=1,NSB
   21 READ(15,1004) N,SP(I+NSA,1),SP(I+NSA,2)
      CLOSE(15)
 1001 FORMAT (A5,3I5,3F10.5/10I5)
 1005 FORMAT (I5,F10.5,F10.2,F10.5,I5,F10.7/10I5)
 1002 FORMAT (3I5,6F10.5)
 1004 FORMAT (I5,2F10.5)
 2101 FORMAT (1H ,'  START      MODEL =',A5)
C
C     -------- ARANGE DATA --------
      JAA(1,1)=1
      DO 15 I=1,NEA
      LL=NEG(I)
      IF (I.NE.1) LM=NEG(I-1)
      DO 15 J=1,LL
      IF (J.NE.1) JAA(I,J)=JBB(I,J-1)+1
      IF (I*J.EQ.1) GO TO 15
      IF (J.EQ.1) JAA(I,J)=JBB(I-1,LM)+1
   15 CONTINUE
      DO 16 I=1,NEA
      LL=NEG(I)
      JA(I)=JAA(I,1)
   16 JB(I)=JBB(I,LL)
      JAA(1+NEA,1)=1+NDA
      DO 25 I=1,NEB
      LL=NEG(I+NEA)
      IF (I.NE.1) LM=NEG(I+NEA-1)
      DO 25 J=1,LL
      IF (J.NE.1) JAA(I+NEA,J)=JBB(I+NEA,J-1)+1
      IF (I*J.EQ.1) GO TO 25
      IF (J.EQ.1) JAA(I+NEA,J)=JBB(I+NEA-1,LM)+1
   25 CONTINUE
      DO 26 I=1,NEB
      LL=NEG(I+NEA)
      JA(I+NEA)=JAA(I+NEA,1)
   26 JB(I+NEA)=JBB(I+NEA,LL)
C
C  ----- SYNTHESIZING DATA -----
      DO 31 I6=1,NEB
      IB=I6+NEA    
      LLB=NEG(IB)
      DO 31 K5=1,LLB
      KAB=JAA(IB,K5)
      KBB=JBB(IB,K5)
      DO 31 J8=KAB,KBB
      X0B=DP(J8,1)
      Y0B=DP(J8,2)
      X1B=DP(J8+1,1)
      Y1B=DP(J8+1,2)
      IF (J8.EQ.KBB) X1B=DP(KAB,1)
      IF (J8.EQ.KBB) Y1B=DP(KAB,2)
      DO 31 I=1,NEA
      LL=NEG(I)
      DO 31 K=1,LL
      KA=JAA(I,K)
      KB=JBB(I,K)
      DO 31 J=KA,KB
      X0=DP(J,1)
      Y0=DP(J,2)
      X1=DP(J+1,1)
      Y1=DP(J+1,2)
      IF (J.EQ.KB) X1=DP(KA,1)
      IF (J.EQ.KB) Y1=DP(KA,2)
      IF(ABS(X0-X1B).GT.0.00001) GOTO 31
      IF(ABS(Y0-Y1B).GT.0.00001) GOTO 31
      IF(ABS(X1-X0B).GT.0.00001) GOTO 31
      IF(ABS(Y1-Y0B).GT.0.00001) GOTO 31
      MM(J)=4
      MM(J8)=4
      MD(J)=J8
      MD(J8)=J
   31 CONTINUE
C
C  ----- OUTPUT SYNTHESIZED DATA -----
      OPEN (16,FILE='DD')
      WRITE(16,1001) TITLE,NE,ND,NS,XS,YS,XYS,
     1    (NSP(J),J=1,10)
      DO 42 I=1,NE
   42 WRITE(16,1005) NEG(I),PRR(I),ENN(I),THH(I),
     1    IP(I),SSG(I),(JBB(I,J),J=1,10)
      DO 40 I=1,ND
   40 WRITE(16,1002) I,MM(I),MD(I),(DP(I,J),J=
     1    1,2),((P(I,J,L),L=1,2),J=1,2)
      DO 41 I=1,NS
   41 WRITE(16,1004) I,SP(I,1),SP(I,2)
      WRITE(*,1006) 99999
      WRITE(16,1006) 99999
 1006 FORMAT(I5)
      CLOSE(16)
      STOP
      END
